/// <reference types="node" />
import { Plugin } from "@webiny/plugins";
import { FileManagerSettings } from "../types";
export interface FilePhysicalStoragePluginParams<U extends FilePhysicalStoragePluginUploadParams, D extends FilePhysicalStoragePluginDeleteParams> {
    upload: (args: U) => Promise<any>;
    delete: (args: D) => Promise<void>;
}
export interface FilePhysicalStoragePluginUploadParams {
    settings: FileManagerSettings;
    buffer: Buffer;
}
export interface FilePhysicalStoragePluginDeleteParams {
    key: string;
}
export declare class FilePhysicalStoragePlugin<U extends FilePhysicalStoragePluginUploadParams = FilePhysicalStoragePluginUploadParams, D extends FilePhysicalStoragePluginDeleteParams = FilePhysicalStoragePluginDeleteParams> extends Plugin {
    static readonly type: string;
    private readonly _params;
    constructor(params: FilePhysicalStoragePluginParams<U, D>);
    upload(params: U): Promise<any>;
    delete(params: D): Promise<any>;
}
